package com.fs.qw.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.fs.qw.domain.QwIpadServer;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

/**
 * ipad服务器Mapper接口
 *
 * @author fs
 * @date 2025-04-29
 */
public interface QwIpadServerMapper extends BaseMapper<QwIpadServer>{
    /**
     * 查询ipad服务器
     *
     * @param id ipad服务器主键
     * @return ipad服务器
     */
    QwIpadServer selectQwIpadServerById(Long id);

    /**
     * 查询ipad服务器列表
     *
     * @param qwIpadServer ipad服务器
     * @return ipad服务器集合
     */
    List<QwIpadServer> selectQwIpadServerList(QwIpadServer qwIpadServer);

    /**
     * 新增ipad服务器
     *
     * @param qwIpadServer ipad服务器
     * @return 结果
     */
    int insertQwIpadServer(QwIpadServer qwIpadServer);

    /**
     * 修改ipad服务器
     *
     * @param qwIpadServer ipad服务器
     * @return 结果
     */
    int updateQwIpadServer(QwIpadServer qwIpadServer);

    /**
     * 删除ipad服务器
     *
     * @param id ipad服务器主键
     * @return 结果
     */
    int deleteQwIpadServerById(Long id);

    /**
     * 批量删除ipad服务器
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteQwIpadServerByIds(Long[] ids);

    @Select("select id from qw_ipad_server where  address_id =#{addressId} and count>0 limit 1 "  )
    Long selectQwIpadServerByAddressId(String addressId);
    @Update("UPDATE qw_ipad_server  SET count = count - 1 WHERE id = #{serverId}")
    void subtractServer(Long serverId);
    @Update("UPDATE qw_ipad_server  SET count = count + 1 WHERE id = #{serverId}")
    void addServer(Long serverId);
    @Select("select id from qw_ipad_server where count>0 order by count desc limit 1 "  )
    Long selectQwIpadServerByOtherAddressId();

}
